unit UnidadMenuPrincipal;

interface

uses
    Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
    Dialogs, StdCtrls, Registry, ShellApi, ExtCtrls, inifiles, ComCtrls;

type
    TformMenuPrincipal = class(TForm)
    tab: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label4: TLabel;
    txtFTP: TEdit;
    txtFTPPuerto: TEdit;
    txtGOPHERPuerto: TEdit;
    txtGOPHER: TEdit;
    Label3: TLabel;
    Label6: TLabel;
    txtSOCKS: TEdit;
    txtSOCKSPuerto: TEdit;
    txtHTTPSPuerto: TEdit;
    txtHTTPS: TEdit;
    Label2: TLabel;
    Label5: TLabel;
    txtHTTP: TEdit;
    txtHTTPPuerto: TEdit;
    Label7: TLabel;
    Label1: TLabel;
    lEstado: TLabel;
    ProxyOverrideEdit: TEdit;
    GroupBox1: TGroupBox;
    opAplicar: TCheckBox;
    opSilecioso: TCheckBox;
    Label13: TLabel;
    Label14: TLabel;
    txtHTTPVPuerto: TEdit;
    Label15: TLabel;
    txtHTTPV: TEdit;
    Label16: TLabel;
    Label17: TLabel;
    txtHTTPSV: TEdit;
    Label18: TLabel;
    txtHTTPSVPuerto: TEdit;
    txtSOCKSVPuerto: TEdit;
    Label19: TLabel;
    txtSOCKSV: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    txtGOPHERV: TEdit;
    Label22: TLabel;
    txtGOPHERVPuerto: TEdit;
    txtFTPVPuerto: TEdit;
    Label23: TLabel;
    txtFTPV: TEdit;
    Label24: TLabel;
    opActivar: TCheckBox;
    Panel1: TPanel;
    bActivar: TButton;
    bDesactivar: TButton;
    Button1: TButton;
    Panel2: TPanel;
    LWEB: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure bActivarClick(Sender: TObject);
    procedure bDesactivarClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LWEBClick2(Sender: TObject);
    private
    { private declarations }
    public
    { public declarations }
    procedure DetectProxy;
    procedure EnableProxy(Enable : Boolean; guardarIPs : boolean);
    end;

var
    formMenuPrincipal: TformMenuPrincipal;
    Proxy: boolean;
    ProxyOverride: string;
    ProxyServer: string;
    Actif : integer;
    Protocoles : string;
    Http, Ftp, Securise, Gopher, Socks : string;
implementation

{$R *.dfm}

procedure TformMenuPrincipal.DetectProxy;
var
  Reg : TRegistry;
  i, j : integer;
begin
  Reg := tRegistry.Create;
  Reg.RootKey := HKEY_CURRENT_USER;
  Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Internet Settings',True);
  ProxyServer:= Reg.ReadString('ProxyServer');
  ProxyOverrideEdit.Text := Reg.ReadString('ProxyOverride');
  Protocoles := Reg.ReadString('ProxyServer');
  Actif := Reg.ReadInteger('ProxyEnable');
  if Actif = 0 then
  begin
    lEstado.Caption := 'PROXY INACTIVO';
    lEstado.Color := clRed;
    bDesactivar.Enabled := false;
  end
  else
  begin
    lEstado.Caption := 'PROXY ACTIVO';
    lEstado.Color := clLime;
    bDesactivar.Enabled := true;
  end;

  Reg.CloseKey;
  Reg.Free;
  txtHTTP.Text := '';
  txtHTTPS.Text := '';
  txtSOCKS.Text := '';
  txtGOPHER.Text := '';
  txtFTP.Text := '';
  txtHTTPPuerto.Text := '';
  txtHTTPSPuerto.Text := '';
  txtSOCKSPuerto.Text := '';
  txtGOPHERPuerto.Text := '';
  txtFTPPuerto.Text := '';
  //si est activada la opcin de Todos los tipos de servidores con la misma
  //ip del pc proxy
  if Pos ('=', ProxyServer) = 0 then
  begin
    txtHTTP.Text := ProxyServer;
    txtHTTPS.Text := ProxyServer;
    txtSOCKS.Text := ProxyServer;
    txtGOPHER.Text := ProxyServer;
    txtFTP.Text := ProxyServer;
  end
  else
  begin
    if Pos('http=', ProxyServer) <> 0 then
    begin
      for i := Pos('http=', ProxyServer) + 5 to Length(ProxyServer) do
      begin
        if (ProxyServer[i] = ';') or (i = Length(ProxyServer) + 1) then
          break
        else
        begin
          if ProxyServer[i] = ':' then
          begin
            j := i + 1;
            while (ProxyServer[j] <> ';') and (j <= Length(ProxyServer) + 1) do
            begin
              txtHTTPPuerto.Text := txtHTTPPuerto.Text + ProxyServer[j];
              Inc(j);
            end;
            break;
          end
          else
            txtHTTP.Text := txtHTTP.Text + ProxyServer[i];
        end;
      end;
    end;
    if Pos('ftp=', ProxyServer) <> 0 then
    begin
      for i := Pos('ftp=', ProxyServer) + 4 to Length(ProxyServer) do
      begin
        if (ProxyServer[i] = ';') or (i = Length(ProxyServer) + 1) then
          break
        else
        begin
          if ProxyServer[i] = ':' then
          begin
            j := i + 1;
            while (ProxyServer[j] <> ';') and (j <= Length(ProxyServer) + 1) do
            begin
              txtFTPPuerto.Text := txtFTPPuerto.Text + ProxyServer[j];
              Inc(j);
            end;
            break;
          end
          else
            txtFTP.Text := txtFTP.Text + ProxyServer[i];
        end;
      end;
    end;
    if Pos('https=', ProxyServer) <> 0 then
    begin
      for i := Pos('https=', ProxyServer) + 6 to Length(ProxyServer) do
      begin
        if (ProxyServer[i] = ';') or (i = Length(ProxyServer) + 1) then
          break
        else
        begin
          if ProxyServer[i] = ':' then
          begin
            j := i + 1;
            while (ProxyServer[j] <> ';') and (j <= Length(ProxyServer) + 1) do
            begin
              txtHTTPSPuerto.Text := txtHTTPSPuerto.Text + ProxyServer[j];
              Inc(j);
            end;
            break;
          end
          else
            txtHTTPS.Text := txtHTTPS.Text + ProxyServer[i];
        end;
      end;
    end;
    if Pos('gopher=', ProxyServer) <> 0 then
    begin
      for i := Pos('gopher=', ProxyServer) + 7 to Length(ProxyServer) do
      begin
        if (ProxyServer[i] = ';') or (i = Length(ProxyServer) + 1) then
          break
        else
        begin
          if ProxyServer[i] = ':' then
          begin
            j := i + 1;
            while (ProxyServer[j] <> ';') and (j <= Length(ProxyServer) + 1) do
            begin
              txtGOPHERPuerto.Text := txtGOPHERPuerto.Text + ProxyServer[j];
              Inc(j);
            end;
            break;
          end
          else
            txtGOPHER.Text := txtGOPHER.Text + ProxyServer[i];
        end;
      end;
    end;
    if Pos('socks=', ProxyServer) <> 0 then
    begin
      for i := Pos('socks=', ProxyServer) + 6 to Length(ProxyServer) do
      begin
        if (ProxyServer[i] = ';') or (i = Length(ProxyServer) + 1) then
          break
        else
        begin
          if ProxyServer[i] = ':' then
          begin
            j := i + 1;
            while (ProxyServer[j] <> ';') and (j <= Length(ProxyServer) + 1) do
            begin
              txtSOCKSPuerto.Text := txtSOCKSPuerto.Text + ProxyServer[j];
              Inc(j);
            end;
            break;
          end
          else
            txtSOCKS.Text := txtSOCKS.Text + ProxyServer[i];
        end;
      end;
    end;
  end;
end;

procedure TformMenuPrincipal.EnableProxy(Enable: Boolean; guardarIPs : boolean);
var
  reg : TRegistry;
  ipProxy : string;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_CURRENT_USER;
  Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Internet Settings',True);
  if guardarIPs then
  begin
    ipProxy := '';
    if txtHTTPV.Text <> '' then
      ipProxy := 'http=' + txtHTTPV.Text + ':' + txtHTTPVPuerto.Text;

    if txtFTPV.Text <> '' then
      if ipProxy <> '' then
        ipProxy := ipProxy + ';ftp=' + txtFTPV.Text + ':' + txtFTPVPuerto.Text
      else
        ipProxy :='ftp=' + txtFTPV.Text + ':' + txtFTPVPuerto.Text;

    if txtGOPHERV.Text <> '' then
      if ipProxy <> '' then
        ipProxy := ipProxy + ';gopher=' + txtGOPHERV.Text + ':' + txtGOPHERVPuerto.Text
      else
        ipProxy :='gopher=' + txtGOPHERV.Text + ':' + txtGOPHERVPuerto.Text;

    if txtHTTPSV.Text <> '' then
      if ipProxy <> '' then
        ipProxy := ipProxy + ';https=' + txtHTTPSV.Text + ':' + txtHTTPSVPuerto.Text
      else
        ipProxy :='https=' + txtHTTPSV.Text + ':' + txtHTTPSVPuerto.Text;

    if txtSOCKSV.Text <> '' then
      if ipProxy <> '' then
        ipProxy := ipProxy + ';socks=' + txtSOCKSV.Text + ':' + txtSOCKSVPuerto.Text
      else
        ipProxy :='socks=' + txtSOCKSV.Text + ':' + txtSOCKSVPuerto.Text;

    Reg.WriteString('ProxyServer', ipProxy);
  end;
  if Enable then
    Reg.WriteInteger('ProxyEnable', 1)
  else
    Reg.WriteInteger('ProxyEnable', 0);
  Reg.CloseKey;
  Reg.Free;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  with tinifile.create (changefileext(paramstr(0), '.ini')) do
  try
   opAplicar.Checked := ReadBool ('Configuracin', 'Ejecutar al iniciar', false);
   opSilecioso.Checked := readBool ('Configuracin', 'Ejecutar silenciosa', false);
   opActivar.Checked := ReadBool ('Configuracin', 'Activar proxy', false);
   txtHTTPV.Text := readString ('IPs Proxy', 'http', '');
   txtHTTPVPuerto.Text := readString ('Puertos Proxy', 'http', '');
   txtHTTPSV.Text := readString ('IPs Proxy', 'https', '');
   txtHTTPSVPuerto.Text := readString ('Puertos Proxy', 'https', '');
   txtFTPV.Text := readString ('IPs Proxy', 'ftp', '');
   txtFTPVPuerto.Text := readString ('Puertos Proxy', 'ftp', '');
   txtGOPHERV.Text := readString ('IPs Proxy', 'gopher', '');
   txtGOPHERVPuerto.Text := readString ('Puertos Proxy', 'gopher', '');
   txtSOCKSV.Text := readString ('IPs Proxy', 'socks', '');
   txtSOCKSVPuerto.Text := readString ('Puertos Proxy', 'socks', '');
  finally
    free;
  end;
  if opAplicar.Checked then
  begin
    if opActivar.Checked then
      EnableProxy(True, True)
    else
      EnableProxy(False, True);
  end;
  if opSilecioso.Checked then
  begin
    Hide;
    Application.Terminate;
  end
  else
    DetectProxy;
end;

procedure TformMenuPrincipal.bActivarClick(Sender: TObject);
begin
  EnableProxy(True, false);
  DetectProxy;
end;

procedure TformMenuPrincipal.bDesactivarClick(Sender: TObject);
begin
  EnableProxy(False, false);
  DetectProxy;
end;

procedure TformMenuPrincipal.Button1Click(Sender: TObject);
begin
  if opSilecioso.Checked then
    MessageDlg('Recuerda que has activado el modo silencioso, con lo cual la aplicacin se ejecutar, realizar los cambios guardados y se cerrar. Para volver al modo normal debers abrir el fichero cproxy.ini y cambiar la clave "Ejecutar silenciosa" a 1.', mtWarning, [mbok], 0);
  close;
end;


procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  with tinifile.create (changefileext(paramstr(0), '.ini')) do
  try
    writeBool ('Configuracin', 'Ejecutar al iniciar', opAplicar.Checked);
    writeBool ('Configuracin', 'Ejecutar silenciosa', opSilecioso.Checked);
    writeBool ('Configuracin', 'Activar proxy', opActivar.Checked);    
    WriteString ('IPs Proxy', 'http', txtHTTPV.Text);
    WriteString ('Puertos Proxy', 'http', txtHTTPVPuerto.Text);
    WriteString ('IPs Proxy', 'https', txtHTTPSV.Text);
    WriteString ('Puertos Proxy', 'https', txtHTTPSVPuerto.Text);
    WriteString ('IPs Proxy', 'ftp', txtFTPV.Text);
    WriteString ('Puertos Proxy', 'ftp', txtFTPVPuerto.Text);
    WriteString ('IPs Proxy', 'gopher', txtGOPHERV.Text);
    WriteString ('Puertos Proxy', 'gopher', txtGOPHERVPuerto.Text);
    WriteString ('IPs Proxy', 'socks', txtSOCKSV.Text);
    WriteString ('Puertos Proxy', 'socks', txtSOCKSVPuerto.Text);
  finally
    free;
  end;
end;

procedure TformMenuPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
